(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KOMBI.PAS                                                      *)
(*  Obsah: program pro vypis kprvkovych kombinaci z nprvkove mnoziny cisel *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 23.12.2014                                            *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program kombinace;
(*Mame mnozinu cisel 1..n, z nich chceme najit vsechny kprvkove kombinace.
Napr. pro n=3 (mnozina {1,2,3}) a k=2 je vysledek {1,2}, {2,3} a {1,3}.
Nalezeni jednoprvkovych kombinaci je trivialni, proste se jeden po druhem
vypisou vsechny prvky zkoumane mnoziny. Asi nejjednodussi postup je pomoci
rekurze si ulohu zjednodusit na serii takovych trivialnich vypisu. Princip:
- Vezmi prvni cislo z mnoziny.
- Najdi vsechny (k-1)prvkove kombinace z ostatnich cisel od druheho dal.
  Nalevo vzdycky pripis to prvni cislo.
- Pak to cele zopakuj pro druhe, treti a dalsi cisla, dokud napravo od nej
  zbyva aspon k-1 cisel.*)

var konec:char;
    n,k:integer;

function NaStr(cislo:integer):string; {pomocna funkce - prevod cisla na string}
var vysledek:string[6];
Begin
str(cislo,vysledek);
nastr:=vysledek;
End;{nastr}

procedure vypis(predchozi:string; {pro predavani drive zpracovanych cisel do hlubsich urovni rekurze}
                pocet, {kolikaprvkove kombinace hledame}
                zacatek,konec:integer); {z jakeho intervalu je hledame (konec je vzdy n)}
var i:integer;
Begin
if pocet>=1
  then for i:=zacatek to konec-pocet+1 do {prvni cislo kombinace postupne posouvame zleva doprava po zkoumanem useku}
         if pocet=1 then write('{',predchozi,i,'}, ') {jednoprvkove kombinace vypisujeme}
                    else vypis(predchozi+nastr(i)+', ',pocet-1,i+1,konec); {pro viceprvkove se zanorime hloubeji}
End;{vypis}
{Uznavam, ze ukladani zpracovanych cisel do stringu je z hlediska vyssich
matematickych principu tak trochu podfuk, ale z hlediska lineho programatora
je to plne funkcni a tedy naprosto dostacujici reseni :-). Jedina drobna
nevyhoda je, ze se tim omezuje rozsah mnoziny (cislo n) na nejakych 65 prvku,
protoze maximalni mozna delka retezce je 255 znaku.
Univerzalnejsi a "poctivejsi" by bylo pouzit pole cisel.}

BEGIN
writeln;
writeln('Vypis vsech k-prvkovych kombinaci z mnoziny n prvku');
writeln('===================================================');
 repeat
 writeln;
 write('Zadej n (0..65): '); readln(n);
 if n>65 then n:=65; {vic cisel se do retezce nevejde (pocitano vcetne carek a mezer)}
 write('Zadej k (0..n): '); readln(k);
 if k>n then k:=n;
 write('Mozne kombinace jsou: ');
 if k=0 then writeln('{}') {mnozina o nula prvcich je prazdna, ale mnozina to je, tak ji vypiseme}
        else vypis('',k,1,n);
 writeln;
 write('Znovu? (A/N) '); readln(konec);
 until upcase(konec)<>'A';
END.